Skip to content
PHP Ecosystem
Explore

IndexAction

API reference › yii › rest › IndexAction

IndexAction implements the API endpoint for listing multiple models.

For more details and usage information on IndexAction, see the guide article on rest controllers.

PropertyTypeDescriptionDefined by
$behaviors read-onlyarray<yii\base\Behavior<static>>List of behaviors attached to this component.yii\base\Component
$checkAccesscallable|nullA PHP callable that will be called when running an action to determine if the current user has the permission to execute the action. Default: null.Action
$controlleryii\base\T|nullThe controller that owns this action, or null when the action runs standalone. via Module::$actionMap Default: null.yii\base\Action
$dataFilteryii\data\DataFilter|nullData filter to be used for the search filter composition. Default: null. Available since 2.0.13.IndexAction
$findModelcallable|nullA PHP callable that will be called to return the model corresponding to the specified primary key value. Default: null.Action
$idstring|nullID of the action; null between construction and dispatcher post-assignment for standalone actions resolved through Module::$actionMap or Module::$actionNamespace. Default: null.yii\base\Action
$modelClassstringClass name of the model which will be handled by this action. Default: null.Action
$moduleyii\base\Module|nullThe owning module, or null if neither a module nor a controller is attached. Available since 22.0.yii\base\Action
$paginationarray|yii\data\Pagination|falseThe pagination to be used by prepareDataProvider(). Default: []. Available since 2.0.45.IndexAction
$prepareDataProvidercallable|nullA PHP callable that will be called to prepare a data provider that should return a collection of the models. Default: null.IndexAction
$prepareSearchQuerycallableA PHP callable that will be called to prepare query in prepareDataProvider. Default: null. Available since 2.0.42.IndexAction
$sortarray|yii\data\Sort|falseThe sorting to be used by prepareDataProvider(). Default: []. Available since 2.0.45.IndexAction
$uniqueId read-onlystringThe unique ID of this action among the whole application.yii\base\Action
MethodDescriptionDefined by
__construct()Constructor.yii\base\Action
__call()Calls the named method which is not a class method.yii\base\Component
__clone()This method is called after the object is created by cloning an existing one.yii\base\Component
__get()Returns the value of a component property.yii\base\Component
__isset()Checks if a property is set, i.e. defined and not null.yii\base\Component
__set()Sets the value of a component property.yii\base\Component
__unset()Sets a component property to be null.yii\base\Component
attachBehavior()Attaches a behavior to this component.yii\base\Component
attachBehaviors()Attaches a list of behaviors to the component.yii\base\Component
behaviors()Returns a list of behaviors that this component should behave as.yii\base\Component
canGetProperty()Returns a value indicating whether a property can be read.yii\base\Component
canSetProperty()Returns a value indicating whether a property can be set.yii\base\Component
className() staticReturns the fully qualified name of this class.yii\base\BaseObject
detachBehavior()Detaches a behavior from the component.yii\base\Component
detachBehaviors()Detaches all behaviors from the component.yii\base\Component
ensureBehaviors()Makes sure that the behaviors declared in behaviors() are attached to this component.yii\base\Component
findModel()Returns the data model based on the primary key given.Action
getBehavior()Returns the named behavior object.yii\base\Component
getBehaviors()Returns all behaviors attached to this component.yii\base\Component
getModule()Returns the module that owns this action when invoked standalone.yii\base\Action
getUniqueId()Returns the unique ID of this action among the whole application.yii\base\Action
hasEventHandlers()Returns a value indicating whether there is any handler attached to the named event.yii\base\Component
hasMethod()Returns a value indicating whether a method is defined.yii\base\Component
hasProperty()Returns a value indicating whether a property is defined for this component.yii\base\Component
init()Initializes the object.Action
off()Detaches an existing event handler from this component.yii\base\Component
on()Attaches an event handler to an event.yii\base\Component
run()IndexAction
runWithParams()Runs this action with the specified parameters.yii\base\Action
setModule()Sets the module that owns this action when invoked standalone.yii\base\Action
trigger()Triggers an event.yii\base\Component
afterRun() protectedThis method is called right after run() is executed.yii\base\Action
beforeRun() protectedThis method is called right before run() is executed.yii\base\Action
prepareDataProvider() protectedPrepares the data provider that should return the requested collection of the models.IndexAction
resolveStandaloneParams() protectedResolves typed parameters of run() when the action is invoked without a hosting controller.yii\base\Action
public yii\data\DataFilter|null $dataFilter = null

Data filter to be used for the search filter composition.

You must set up this field explicitly in order to enable filter processing. For example:

[
'class' => 'yii\data\ActiveDataFilter',
'searchModel' => function () {
return (new \yii\base\DynamicModel(['id' => null, 'name' => null, 'price' => null]))
->addRule('id', 'integer')
->addRule('name', 'trim')
->addRule('name', 'string')
->addRule('price', 'number');
},
]

Since

2.0.13

public array|yii\data\Pagination|false $pagination = []

The pagination to be used by prepareDataProvider().

If this is false, it means pagination is disabled. Note: if a Pagination object is passed, it’s params will be set to the request parameters.

Since

2.0.45

public callable|null $prepareDataProvider = null

A PHP callable that will be called to prepare a data provider that should return a collection of the models.

If not set, prepareDataProvider() will be used instead. The signature of the callable should be:

function (IndexAction $action) {
// $action is the action object currently running
}

The callable should return an instance of ActiveDataProvider.

If $dataFilter is set the result of DataFilter::build() will be passed to the callable as a second parameter. In this case the signature of the callable should be the following:

function (IndexAction $action, mixed $filter) {
// $action is the action object currently running
// $filter the built filter condition
}
public callable $prepareSearchQuery = null

A PHP callable that will be called to prepare query in prepareDataProvider.

Should return $query. For example:

function ($query, $requestParams) {
$query->andFilterWhere(['id' => 1]);
...
return $query;
}

Since

2.0.42

public array|yii\data\Sort|false $sort = []

The sorting to be used by prepareDataProvider().

If this is false, it means sorting is disabled. Note: if a Sort object is passed, it’s params will be set to the request parameters.

Since

2.0.45

public function run(): yii\data\ActiveDataProvider
protected function prepareDataProvider(): yii\data\ActiveDataProvider

Prepares the data provider that should return the requested collection of the models.